/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
var CITY_CHANGES = "1";
var aryTargetId;

/**
 * 画面読込時追加処理
 * @param 無し
 * @return 無し
 * @throws 実行時例外
 */
function onLoadExtra() {
	// 項目背景色設定
	setFieldsBgColor(ARY_FIELDS_ID,     COLOR_FIELD_NORMAL);
	setFieldsBgColor(ARY_ERR_FIELDS_ID, COLOR_FIELD_ERROR);
	// 項目長設定
	setMaxLength(PRM_TXT_CITY_CODE      , LEN_CITY_CODE      );
	setMaxLength(PRM_TXT_RETIRE_COUNT   , LEN_RETIRE_COUNT   );
	setMaxLength(PRM_TXT_CITY_PAY_AMOUNT, LEN_CITY_PAY_AMOUNT);
	setMaxLength(PRM_TXT_CITY_TAX       , LEN_CITY_TAX       );
	setMaxLength(PRM_TXT_PREFECTURE_TAX , LEN_PREFECTURE_TAX );
	
		// 金額項目の配列
	aryTargetId = new Array(
		PRM_TXT_CITY_PAY_AMOUNT,
		PRM_TXT_CITY_TAX,
		PRM_TXT_PREFECTURE_TAX
	);
	
	// カンマ挿入
	setAllInsertComma();
		// フォーカス喪失イベントハンドラ設定
//	setFieldsOnBlurHandler(aryTargetId, onLostFocusExtra);
		// フォーカス取得イベントハンドラ設定
	setOnFocusHandler(aryTargetId);
	// フォーカス設定
	setFocus(PRM_TXT_CITY_CODE);
}

function onLostFocusExtra(e) {
	var objTarget = getSrcElement(e);
	if (chkTargetObject(objTarget)) {
		if(!objTarget.readOnly) {
			insertComma(objTarget);
		}
	}

}


function onFocusExtra(e) {
	var objTarget = getSrcElement(e);
	if (chkTargetObject(objTarget)) {
		if(!objTarget.readOnly) {
			delComma(getObject(objTarget));
		}
	}

}

function chkTargetObject(objTarget) {
	for (var i = 0; i < aryTargetId.length; i++) {
		if (objTarget == getObject(aryTargetId[i])) {
			return true;
		}
		if (i == aryTargetId.length - 1) {
			return false;
		}
	}
}


/**
 * サーバー通信処理
 * @param 無し
 * @return 無し
 * @throws 実行時例外
 */
function submitForm(objForm, cmd) {
	// カンマ削除
	setAllDelComma();
	// 入力チェック
	if (validate()) {
		// サーバー通信(入力エラー無の場合)
		doSubmitMessage(objForm, cmd, 'QC0001', '');
	}
}

/**
 * 確認メッセージ付きsubmit処理
 * @param objForm フォームオブジェクト
 * @param cmd     コマンド
 * @param code    メッセージコード
 * @param rep     変換文字列
 * @return 無し
 * @throws 実行時例外
 */
function doSubmitMessage(objForm, cmd, code, rep) {
	// 問合中フラグ確認
	if (inquiring) {
		return;
	}
	if (!confirm(getMessage(code, rep))) {
		// カンマ挿入
		setAllInsertComma();
		return;
	}
	// submit
	doSubmit(objForm, cmd);
}

/**
 * 入力チェック
 * @param 無し
 * @return チェック結果(true：OK、false：NG)
 * @throws 実行時例外
 */
function validate() {
	// フィールド背景色設定
	setFieldsBgColor(ARY_FIELDS_ID, COLOR_FIELD_NORMAL);
	// 入力チェック
	var aryMessage = new Array();
	// 入力チェック
	var aryMessage = new Array();
	checkRequired(PRM_TXT_CITY_CODE      , NAM_CITY_CODE      , aryMessage );
	// 異動ありに設定されていたら
	if (getFormValue(PRM_PLT_CITY_CHANGES) == CITY_CHANGES) {
		checkRequired(PRM_TXT_RETIRE_COUNT   , NAM_RETIRE_COUNT   , aryMessage );
		checkRequired(PRM_TXT_CITY_PAY_AMOUNT, NAM_CITY_PAY_AMOUNT, aryMessage );
		checkRequired(PRM_TXT_CITY_TAX       , NAM_CITY_TAX       , aryMessage );
		checkRequired(PRM_TXT_PREFECTURE_TAX , NAM_PREFECTURE_TAX , aryMessage );
	}
	checkCode(PRM_TXT_CITY_CODE    , NAM_CITY_CODE     , aryMessage );
	checkNumeric(PRM_TXT_RETIRE_COUNT   , NAM_RETIRE_COUNT   , aryMessage );
	checkNumeric(PRM_TXT_CITY_PAY_AMOUNT, NAM_CITY_PAY_AMOUNT, aryMessage );
	checkNumeric(PRM_TXT_CITY_TAX       , NAM_CITY_TAX       , aryMessage );
	checkNumeric(PRM_TXT_PREFECTURE_TAX , NAM_PREFECTURE_TAX , aryMessage );
	if (aryMessage.length == 0) {
		return true;
	} else {
		showMessage(aryMessage);
		return false;
	}
}


/**
 * カンマ挿入
 * @param sourceStr 対象文字列
 * @return 無し
 * @throws 実行時例外
 */
function insertComma(objTarget) {
	var destStr = getFormValue(objTarget);
	var tmpStr = "";
	while (destStr != (tmpStr = destStr.replace(/^([+-]?\d+)(\d\d\d)/,"$1,$2"))) {
		destStr = tmpStr;
	}
	setFormValue(objTarget, destStr);
}

/**
 * カンマ削除
 * @param w 対象文字列
 * @return 無し
 * @throws 実行時例外
 */
function delComma(objTarget) {

	var targetMonney = getFormValue(objTarget);
	setFormValue(objTarget, targetMonney.replace(/,/g,""));
}

/**
 * 全項目カンマ挿入
 * @param 無し
 * @return 無し
 * @throws 実行時例外
 */
function setAllInsertComma() {
	// 初期表示時カンマ挿入
	for (var i = 0; i < aryTargetId.length; i++) {
		insertComma(getObject(aryTargetId[i]));
	}
}

/**
 * 全項目カンマ削除
 * @param 無し
 * @return 無し
 * @throws 実行時例外
 */
function setAllDelComma() {
	// カンマ削除
	for (var i = 0; i < aryTargetId.length; i++) {
		delComma(getObject(aryTargetId[i]));
	}
}
